/*******************************************************
*
*	SM3D Utility routine
*
********************************************************
*	SM3D
*
*	File type	:	Source CPP
*	Author		:	Dario Deledda
*	Date		:	25/11/2000
*	Last update	:	25/11/2000
*	Version		:	0.9a
*
********************************************************/
#include "../header/SM3DColor.h"

smRGB smRGB::operator=(smRGB16 op1){
	b=(op1.cl & smBlueMask)<<3;
	g=(op1.cl & smGreenMask)>>2;
	r=(op1.cl & smRedMask)>>7;
	return *this;
}
smRGB smRGB::operator=(smRGB op1){
	b=op1.b;
	g=op1.g;
	r=op1.r;
	a=op1.a;
	
	v=op1.v;
	n=op1.n;
	return *this;
}

void smRGB::CutCol(){
	if (r<-max_col) r=-max_col; else if(r>max_col) r=max_col;
	if (g<-max_col) g=-max_col; else if(g>max_col) g=max_col;
	if (b<-max_col) b=-max_col; else if(b>max_col) b=max_col;
	if (a<-max_col) a=-max_col; else if (a>max_col) a=max_col;
}

void smRGB::CutColU(){
	if (r>max_col) r=max_col; else if(r<0) r=0;
	if (g>max_col) g=max_col; else if(g<0) g=0;
	if (b>max_col) b=max_col; else if(b<0) b=0;
	if (a>max_col) a=max_col; else if (a<0) a=0;
}
 
smRGB16 smRGB16::operator=(smRGB op1){
	cl = (smRed8to5(op1.r) | smGreen8to5(op1.g) | smBlue8to5(op1.b) );
	return *this;
}

smRGB16 smRGB16::operator=(Int16 op1){
	cl=op1;
	return *this;
}

smRGB16 smRGB16::operator+(register smRGB16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)+smRed5to8(op1.cl);
	go=smGreen5to8(cl)+smGreen5to8(op1.cl);
	bo=smBlue5to8(cl)+smBlue5to8(op1.cl);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;

}

smRGB16 smRGB16::operator-(register smRGB16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)-smRed5to8(op1.cl);
	go=smGreen5to8(cl)-smGreen5to8(op1.cl);
	bo=smBlue5to8(cl)-smBlue5to8(op1.cl);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;

}

smRGB16 smRGB16::operator*(register smRGB16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)*smRed5to8(op1.cl);
	go=smGreen5to8(cl)*smGreen5to8(op1.cl);
	bo=smBlue5to8(cl)*smBlue5to8(op1.cl);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;
}

smRGB16 smRGB16::operator/(register smRGB16 op1){
	register smRGB16 tmp;
	register Int16	ro=0xff,go=0xff,bo=0xff;
	
	if(smRed5to8(op1.cl) != 0)
		ro=smRed5to8(cl)/smRed5to8(op1.cl);
	if(smGreen5to8(op1.cl) != 0)
		go=smGreen5to8(cl)/smGreen5to8(op1.cl);
	if(smBlue5to8(op1.cl) != 0)
		bo=smBlue5to8(cl)/smBlue5to8(op1.cl);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;
}

smRGB16 smRGB16::operator+(register Int16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)+op1;
	go=smGreen5to8(cl)+op1;
	bo=smBlue5to8(cl)+op1;
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator-(register Int16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)-op1;
	go=smGreen5to8(cl)-op1;
	bo=smBlue5to8(cl)-op1;
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator*(register Int16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=smRed5to8(cl)*op1;
	go=smGreen5to8(cl)*op1;
	bo=smBlue5to8(cl)*op1;
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator/(register Int16 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	if (op1 == 0) { tmp.cl=0x7fff; return tmp;}
	
	ro=smRed5to8(cl)/op1;
	go=smGreen5to8(cl)/op1;
	bo=smBlue5to8(cl)/op1;
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator+(register Fl32 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=(Int16)((Fl32)smRed5to8(cl)+op1);
	go=(Int16)((Fl32)smGreen5to8(cl)+op1);
	bo=(Int16)((Fl32)smBlue5to8(cl)+op1);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator-(register Fl32 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=(Int16)((Fl32)smRed5to8(cl)-op1);
	go=(Int16)((Fl32)smGreen5to8(cl)-op1);
	bo=(Int16)((Fl32)smBlue5to8(cl)-op1);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator*(register Fl32 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	ro=(Int16)((Fl32)smRed5to8(cl)*op1);
	go=(Int16)((Fl32)smGreen5to8(cl)*op1);
	bo=(Int16)((Fl32)smBlue5to8(cl)*op1);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}

smRGB16 smRGB16::operator/(register Fl32 op1){
	register smRGB16 tmp;
	register Int16	ro,go,bo;
	
	if( op1 == Fl32(0.0) ){ tmp.cl=0x7fff; return tmp;}
	ro=(Int16)((Fl32)smRed5to8(cl)/op1);
	go=(Int16)((Fl32)smGreen5to8(cl)/op1);
	bo=(Int16)((Fl32)smBlue5to8(cl)/op1);
	
	ro=smColorClip8(ro);
	go=smColorClip8(go);
	bo=smColorClip8(bo);
	
	tmp.cl=(bo | ro << smGreenShift | go << smRedShift);
	return tmp;	
}